/**
 * injects a loadable tracker on a given global variable name.
 *
 * WARNING: mutates the origin variable!
 *
 * @param name = 'importedComponents`
 * @example
 * ```js
 * window.importedMarks = window.importedMarks || [];
 * importedMarks.push(hydratedMarks[0]);
 * ///
 * injectLoadableTracker();
 */
export declare const injectLoadableTracker: (name?: string) => void;
export declare const getLoadableTrackerCallback: (name?: string) => (marks: string[]) => string;
