import { isBackend } from '../utils/detectBackend';
const rejectNetwork = (url) => url.indexOf('http') !== 0;
const localSettings = {
    hot: (!!module).hot,
    SSR: isBackend,
    rethrowErrors: process.env.NODE_ENV !== 'production',
    fileFilter: rejectNetwork,
    checkSignatures: true,
};
export const settings = {
    get hot() {
        return localSettings.hot;
    },
    get SSR() {
        return localSettings.SSR;
    },
    get rethrowErrors() {
        return localSettings.rethrowErrors;
    },
    get fileFilter() {
        return localSettings.fileFilter;
    },
    get checkSignatures() {
        return localSettings.checkSignatures;
    },
};
/**
 * allows fine tune imported logic
 * client side only!
 * @internal
 * @see configuration via imported.json {@link https://github.com/theKashey/react-imported-component#importedjs}
 */
export const setConfiguration = (config) => {
    Object.assign(localSettings, config);
};
